class String
  def extractMeta
    self[/#{"\""}(.*?)#{"\""}/m, 1]
  end
end

class String
  def removeIndex
    self.partition(' ')[-1]
  end
end

def parseCollection searchColl
  $client.communities.all.each do |community|
    $client.communities.collections(:id => community.id).each do |collection|
      if((searchColl.gsub('_',' ') <=> collection.name) == 0)
        return(collection.id)
      end
    end
  end
  return(0)
end

def parseCommunity searchComm
  $client.communities.all.each do |community|
    if(I18n.transliterate(searchComm).removeIndex == I18n.transliterate(community.name).removeIndex)
        return(community.id)
    end
  end
  return(0)
end
def parseItem searchItem
  $client.communities.all.each do |community|
    $client.communities.collections(:id => community.id).each do |collection|
      $client.collections.items(:id => collection.id, limit: 10, offset: 0, expand: "metadata").each do |item|
        puts "name: #{item.name}"
        if(searchItem == item.name)
          return(item.id)
        end
      end
      return(0)
    end
  end
end
def getName meta
  f = File.open(meta, "r")
  i = 0
  f.each_line{|line|
    if(i == 1)
      return(line.extractMeta)
    end
  i += 1
  }
end

def getDescription meta
  f = File.open(meta, "r")
  i = 0
  f.each_line{|line|
    if(i == 2)
      return(line.extractMeta)
    end
  i += 1
  }
end

def getItemMeta meta
  f = File.open(meta, "r")
  i = 0
  metaArray = Array.new
  f.each_line{|line|
    metaArray << line.extractMeta
  }
  return(metaArray)
end

def coleRec file, id
  g = Dir[file + "/*"].sort
  g.each{|file|
    if(file.split('.')[-1] != "metadata")
    target = file
    fileName = target.split('/')[-1]
    target = fileName.split("_")
    if(target[0] == "COL")
    meta = file + "/" + file.split('/')[-1] +".metadata"
    name = getName(meta)
      #p "Colecao #{file.split('/')[-1]}"
      if(parseCollection(name) == 0)
      description = getDescription(meta)
      if(id != 0)
          $hit += 1
          coll = $client.communities.create_collection(
          Dspace::Collection.new(
              {
                'name' => name,
                'introductoryText' => description
              }
              ),
              id: id
              )

    else

    $miss += 1
    end
    end
  end

    if(target[0] == "NUCLEO")
      fileName = fileName[7..-1].gsub('_',' ')
      id = parseCommunity(fileName)
      if(id == 0)
         p "File Name: #{fileName}"
      end
      # p id
      coleRec(file,id)
    end

  #   if(target[0] == "ITEM")
  #     meta = file + "/" + file.split('/')[-1] +".metadata"
  #     metarray = getItemMeta(meta)
  #     title = metarray[0]
  #     metarray.delete_at(0)
  #     author = metarray[0]
  #     metarray.delete_at(0)
  #     description = metarray[-1]
  #     metarray.delete_at(-1)
  #     keywords = metarray
  #     item_metadata = Dspace::Item.new(
  #       'metadata' => [
  #         {'key' => "dc.title", 'value' => title},
  #         {'key' => "dc.creator",'value' => author},
  #         {'key' => "dc.description", 'value' => description}
  #
  #       ]
  #     )
  #     if(id != 0)
  #     item = $client.collections.create_item(item_metadata, id: id)
  #     filename = file.split('/')[-1]
  #     itemFile = File.new(file + "/" + filename[5..-1] + ".pdf")
  #     itemID = parseItem(name)
  #     if(itemID != 0)
  #     $client.items.add_bitstream(
  #       itemFile,
  #       id: itemID,
  #       name: name,
  #       description: description
  #     )
  #     endI18n.available_locales = [:en]
  #   end
  # end
end

  }
end
###################################################################################################
$LOAD_PATH.unshift('/home/starosta/c3sl/dspace-scripts/dspace-rest-client/lib')
#################################### A U T E N T I C A C A O ######################################
require 'dspace'
require "i18n"
I18n.available_locales = [:en]

$client = Dspace::Client.new(dspace_api: 'https://seppirdev.c3sl.ufpr.br:8443/rest')
if !$client.is_running?
  raise 'Can\'t connect to DSpace API.'
end
$client.login 'admin@seppirdev.com', 'adminadmin'
#################################### C O L E C O E S ##############################################
$hit = 0
$miss = 0
root ='/home/starosta/c3sl/dspaceFiles/BANCO-SEPPIR-20160624/'
d = Dir[root + "*"].sort
d.each{|file|
  com = file
  nameFile = file.split("/")[-1]
  nameFile = nameFile[7..-1]
  nameFile = nameFile.gsub('_',' ')
  # p "File: #{nameFile}"
   id = parseCommunity(nameFile)
  # p id
  # p com[1]
  coleRec(file,id)
}
puts"Hits: #{$hit} Misses: #{$miss}"
